#include "MemAccess.h"
#include <stdlib.h>

int
main(int argc, char** argv)
{
	unsigned long low  = 0xfffc21C3;
	unsigned long high = 0xfffc8753;
	unsigned long pulsewidth = low/2 + high/2;

	if (argc > 1)
	{
		unsigned long diff = high - low;
		double val = atof(argv[1]);
		if (val < 0) val = 0;
		if (val > 1) val = 1;
		pulsewidth = low + (unsigned long)(val * (high - low));
	}
	
	MemAccess mem;

	mem.write32Bits(0x48088024, 0x00000000); // set gtp11_TCLR, stop the timer
	mem.write16Bits(0x48002178, 0x0102);     // set mux for gpt11_pwm_evt
	mem.write32Bits(0x48004a40, 0x0000038A); // use the system clock
	mem.write32Bits(0x4808802c, 0xfffc085F); // set value for gpt11_TLDR, timer load
	mem.write32Bits(0x48088038, pulsewidth); // set the pulse width
	mem.write32Bits(0x48088028, 0xffffffff); // set value for gpt11_TCRR, timercounter
	mem.write32Bits(0x48088024, 0x00001843); // set gtp11_TCLR, start the timer
}
